package Clases;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;

public class Automata {
	Estado estadoActual;
	Estado estadoInicial;
	Estado estadoEspera;
	Estado estadoNuevoMensaje;
	Estado estadoLibretaDirecciones;
	Estado modoManual;
	Estado estadoFin;
	ArrayList<Estado> listaEstados;
	
	public Automata(Estado e) {
		super();
		this.estadoActual = e;
		this.estadoInicial = e;
		this.listaEstados = new ArrayList<Estado>();
		this.estadoEspera = new Estado("estadoEspera");
		this.estadoEspera.addTransicion("continuar","",this.estadoInicial);
		this.modoManual = new Estado("modoManual");

		this.estadoFin = new Estado("estadoFin");		
		this.estadoNuevoMensaje = new Estado("nuevoMensaje");
		this.estadoLibretaDirecciones = new Estado("libretaDirecciones");
	}
	
	public Estado getEstadoActual(){
		return this.estadoActual;
	}
	
	public Estado getEstadoNuevoMensaje(){
		return this.estadoNuevoMensaje;
	}
	
	public Estado getEstadoLibretaDirecciones(){
		return this.estadoLibretaDirecciones;
	}
	
	public Estado getEstadoFin(){
		return this.estadoFin;
	}
	
	public Estado getEstadoManual(){
		return this.modoManual;
	}
	
	public Estado getEstadoEspera(){
		return this.estadoEspera;
	}
	
	public Estado getEstadoInicial(){
		return this.estadoInicial;
	}
	
	public Estado getEstadoByName(String name){
		try{
			Iterator<Estado> it = listaEstados.iterator();
		
			Estado e;
			while(it.hasNext()){
				e = it.next();
				if(name.equalsIgnoreCase(e.getNombre())) return e;
			}
		} catch(NullPointerException e){
			System.out.println("ERROR: No se ha encontrado el estado \""+name+"\" en el automata");
			e.printStackTrace();
			System.exit(1);
		}

		return null;
	}
		
	public void addTransicion(Estado origen, String frase, String accion, Estado destino){
		Transicion tr = new Transicion(origen,frase,accion,destino);
		origen.addTransicion(tr);
		if(!listaEstados.contains(destino)){
			listaEstados.add(destino);
//			System.out.println("    \""+destino.getNombre()+"\" agregado al automata");
		}
	}
	
	public int trans(String line) throws IOException, InterruptedException{
		Iterator<Transicion> it = estadoActual.transiciones.iterator();
		Transicion tr = null;
		boolean found = false;
		while(it.hasNext()){
			tr = it.next();
			if(tr.frase.equalsIgnoreCase(line)){
				found = true;
				break;
			}
		}
		if (!found){
			System.out.println("    No se ha encontrado la transición buscada (\""+line+"\")");
			return -1;
		}else{
			estadoActual = tr.destino;
			tr.ejecutarAccion();
			return 0;
		}
	}
}