package Gestores;

import Clases.Automata;
import Clases.Estado;
import Principal.TecladoUtils;

public class GestorLibretaDirecciones {
	TecladoUtils u;
	
	public GestorLibretaDirecciones(){
		u = new TecladoUtils();
	}
	
	public void rellenarLibretaDirecciones(Automata aut){
		Estado o = aut.getEstadoLibretaDirecciones();
		Estado e = new Estado("estadoEspera-Libreta");
		e.addTransicion("continuar","",o);
		
		aut.addTransicion(o, "nuevo contacto", "Control_L+N", e);
		aut.addTransicion(o, "nueva lista", "Alt_L+A, N, L", e);
		aut.addTransicion(o, "propiedades", "Control_L+I", e);
		
		// Se cierra la ventana de direcciones. Así, al cerrar la de
		// "nuevo mensaje", iremos a la principal: concordancia entre autómata
		// y estado del programa
		aut.addTransicion(o, "redactar",
				"Control_L+m,Alt_L+Tab,Alt_L+F4",
				aut.getEstadoNuevoMensaje());
		aut.addTransicion(o, "eliminar", "Delete", e);
		
		Estado e2 = new Estado("estadoEspera-Libreta");
		e2.addTransicion("continuar","Tab,Tab",o);
		o.addTransicion("buscar", "Control_L+K", e2);
		aut.addTransicion(o, "cerrar", "Alt_L+F4", aut.getEstadoInicial());
		aut.addTransicion(o, "cerrar ventana", "Alt_L+F4", aut.getEstadoInicial());
		aut.addTransicion(o, "siguiente contacto", "Down", o); 
		aut.addTransicion(o, "anterior contacto", "Up", o); 
		aut.addTransicion(o, "abrir contacto", "Return", e); 

		aut.addTransicion(o, "siguiente libreta", "Shift_L+Tab,Down,Tab", o);
		aut.addTransicion(o, "anterior libreta", "Shift_L+Tab,Up,Tab", o);
		aut.addTransicion(o, "nueva libreta", "Alt_L+A,N,B", o);
		aut.addTransicion(o, "nueva libreta de direcciones", "Alt_L+A,N,B", o);
		
		
		Estado menuArchivo = new Estado("libretaDirecciones-MenuArchivo");
		aut.addTransicion(o, "abrir menu archivo", "Alt_L+a",menuArchivo);
		aut.addTransicion(o, "menu archivo", "Alt_L+a",menuArchivo);
		
		Estado menuEditar = new Estado("libretaDirecciones-MenuEditar");
		aut.addTransicion(o, "abrir menu editar", "Alt_L+e",menuEditar);
		aut.addTransicion(o, "menu editar", "Alt_L+e",menuEditar);
		
		Estado menuVer = new Estado("libretaDirecciones-MenuVer");
		aut.addTransicion(o, "abrir menu ver", "Alt_L+v",menuVer);
		aut.addTransicion(o, "menu ver", "Alt_L+v",menuVer);

		Estado menuHerramientas = new Estado("libretaDirecciones-MenuHerramientas");
		aut.addTransicion(o, "abrir menu herramientas", "Alt_L+t",menuHerramientas);
		aut.addTransicion(o, "menu herramientas", "Alt_L+t", menuHerramientas);
		
		Estado menuAyuda = new Estado("libretaDirecciones-MenuAyuda");
		aut.addTransicion(o, "abrir menu ayuda", "Alt_L+u",menuAyuda);
		aut.addTransicion(o, "menu ayuda", "Alt_L+u", menuAyuda);	
		
		rellenarMenuArchivo(aut);
		rellenarMenuVer(aut);
		rellenarMenuHerramientas(aut);
		rellenarMenuAyuda(aut);
	}
	
	public void rellenarMenuArchivo(Automata aut){
		Estado o = aut.getEstadoByName("libretaDirecciones-MenuArchivo");
		Estado i = aut.getEstadoLibretaDirecciones();
		Estado e = aut.getEstadoByName("estadoEspera-Libreta");
		
		Estado nuevo = new Estado("libretaDirecciones-MenuArchivo-Nuevo");
		aut.addTransicion(o, "nuevo", "n", nuevo);
		rellenarMenuArchivoNuevo(aut);
		
		aut.addTransicion(o, "vista preliminar del contacto", "v", e);
		aut.addTransicion(o, "imprimir contacto", "p", e);
		aut.addTransicion(o, "configurar pagina", "u", e);
		aut.addTransicion(o, "vista preliminar de la libreta de direcciones", "b", e);
		aut.addTransicion(o, "imprimir libreta de direcciones", "a", e);
		aut.addTransicion(o, "cerrar", "c", aut.getEstadoInicial());

		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuArchivoNuevo(Automata aut){
		Estado o = aut.getEstadoByName("libretaDirecciones-MenuArchivo-Nuevo");
		Estado i = aut.getEstadoLibretaDirecciones();
		Estado e = aut.getEstadoByName("estadoEspera-Libreta");
		
		aut.addTransicion(o, "contacto de la libreta de direcciones", "c", e);
		aut.addTransicion(o, "lista de correo", "l", e);
		aut.addTransicion(o, "libreta de direcciones", "b", e);
		aut.addTransicion(o, "directorio ele de a pe", "d", e);
		aut.addTransicion(o, "mensaje", 
				"Control_L+m,Alt_L+Tab,Alt_L+F4", aut.getEstadoNuevoMensaje());
		
		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuEditar(Automata aut){
		Estado o = aut.getEstadoByName("libretaDirecciones-MenuEditar");
		Estado i = aut.getEstadoLibretaDirecciones();
		Estado e = aut.getEstadoByName("estadoEspera-Libreta");
		
		aut.addTransicion(o, "deshacer", "Escape,Control_L+Z", i);
		aut.addTransicion(o, "rehacer", "Escape,Control_L+Shift_L+Z", i);
		aut.addTransicion(o, "copiar", "Escape,Control_L+C", i);
		aut.addTransicion(o, "cortar", "Escape,Control_L+X", i);
		aut.addTransicion(o, "pegar", "Escape,Control_L+", i);
		aut.addTransicion(o, "eliminar contacto", "Escape,Delete", i);
		aut.addTransicion(o, "seleccionar todo", "Escape,Control_L+A", i);
		aut.addTransicion(o, "buscar direcciones", "s", e);
		aut.addTransicion(o, "propiedades", "i", e);
		aut.addTransicion(o, "preferencias", "n", e);

		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuVer(Automata aut){
		Estado o = aut.getEstadoByName("libretaDirecciones-MenuVer");
		Estado i = aut.getEstadoLibretaDirecciones();
		
		Estado barras = new Estado("libretaDirecciones-MenuVer-BarrasDeHerramientas");
		aut.addTransicion(o, "barras de herramientas", "h", barras);
		rellenarMenuVerBarrasDeHerramientas(aut);
		
		Estado d = new Estado("libretaDirecciones-MenuVer-Disposicion");
		aut.addTransicion(o, "disposicion", "d", d);
		rellenarMenuVerDisposicion(aut);
		
		Estado mostrarNombre = new Estado("libretaDirecciones-MenuVer-MostrarNombreComo");
		aut.addTransicion(o, "mostrar nombre como", "n", mostrarNombre);
		rellenarMenuVerMostrarNombreComo(aut);
		
		Estado ordenar = new Estado("libretaDirecciones-MenuVer-OrdenarPor");
		aut.addTransicion(o, "ordenar por", "o", ordenar);
		rellenarMenuVerOrdenarPor(aut);
		
		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuVerBarrasDeHerramientas(Automata aut){
		Estado o = aut.getEstadoByName("libretaDirecciones-MenuVer-BarrasDeHerramientas");
		Estado i = aut.getEstadoLibretaDirecciones();
		Estado e = aut.getEstadoByName("estadoEspera-Libreta");
		
		aut.addTransicion(o, "barra de estado", "s", i);
		aut.addTransicion(o, "barra de herramientas de la libreta de direcciones",
				"Return", i);
		aut.addTransicion(o, "personalizar", "p", e); 
		
		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuVerDisposicion(Automata aut){
		Estado o = aut.getEstadoByName("libretaDirecciones-MenuVer-Disposicion");
		Estado i = aut.getEstadoLibretaDirecciones();
	
		aut.addTransicion(o, "panel de contactos", "p", i);
		aut.addTransicion(o, "panel de directorio", "a", i);
		
		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuVerMostrarNombreComo(Automata aut){
		Estado o = aut.getEstadoByName("libretaDirecciones-MenuVer-MostrarNombrecomo");
		Estado i = aut.getEstadoLibretaDirecciones();
	
		aut.addTransicion(o, "apellidos nombre", "l", i);
		aut.addTransicion(o, "nombre y apellidos", "m", i);
		aut.addTransicion(o, "nombre mostrado", "d", i);
		
		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuVerOrdenarPor(Automata aut){
		Estado o = aut.getEstadoByName("libretaDirecciones-MenuVer-OrdenarPor");
		Estado i = aut.getEstadoLibretaDirecciones();
	
		aut.addTransicion(o, "nombre", "n", i);
		aut.addTransicion(o, "correo electronico", "e", i);
		aut.addTransicion(o, "nombre en el chat", "c,Return", i);
		aut.addTransicion(o, "organizacion", "z", i);
		aut.addTransicion(o, "apodo", "d,Return", i);
		aut.addTransicion(o, "correo electronico adicional", "l", i);
		aut.addTransicion(o, "departamento", "r", i);
		aut.addTransicion(o, "puesto", "t,Return", i);
		aut.addTransicion(o, "movil", "m", i);
		aut.addTransicion(o, "buscapersonas", "p", i);
		aut.addTransicion(o, "fax", "f", i);
		aut.addTransicion(o, "telefono particular", "c,c,Return", i);
		aut.addTransicion(o, "telefono del trabajo", "t,t,Return", i);
		aut.addTransicion(o, "ascendente", "a", i);
		aut.addTransicion(o, "descendente", "d,d,Return", i);
		
		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuHerramientas(Automata aut){
		Estado o = aut.getEstadoByName("libretaDirecciones-MenuHerramientas");
		Estado i = aut.getEstadoLibretaDirecciones();
		
		aut.addTransicion(o, "correo y noticias",
				"o,Alt_L+Tab,Alt_L+F4", aut.getEstadoInicial());
		Estado e = new Estado("estadoEspera-Libreta");
		e.addTransicion("continuar","",i);
		aut.addTransicion(o, "importar", "i", e);
		aut.addTransicion(o, "exportar", "e", e);
		
		aut.addTransicion(o, "cancelar", "Escape", i);
	}
	
	public void rellenarMenuAyuda(Automata aut){
		Estado o = aut.getEstadoByName("libretaDirecciones-MenuAyuda");
		Estado i = aut.getEstadoLibretaDirecciones();
		Estado e = aut.getEstadoByName("estadoEspera-Libreta");
		
		aut.addTransicion(o, "acerca de thunderbird", "t", e);
		aut.addTransicion(o, "acerca de zanderberd", "t", e);
		aut.addTransicion(o, "contenidos de la ayuda", "u", e);
		aut.addTransicion(o, "notas de esta version", "n", aut.getEstadoInicial());
		aut.addTransicion(o, "que hay de nuevo", "q", aut.getEstadoInicial());
		aut.addTransicion(o, "reiniciar con los complementos desactivados", 
				"r", aut.getEstadoInicial());

		aut.addTransicion(o, "cancelar", "Escape", i);		
	}
}
