package Pack;
import java.util.ArrayList;


public class Estado {
	private int numero;
	private String palabra;
	private ArrayList<Transicion> transiciones;
	
	public Estado(int n, String p){
		this.numero = n;
		this.palabra = p;
		transiciones = new ArrayList<Transicion>();
	}
	
	public void addTransicion(Estado e){
		Transicion t = new Transicion(this, e);
		this.transiciones.add(t);
	}
	public void addTransicion(Estado e, String palabra){
		Transicion t = new Transicion(this, e);
		t.setPalabra(palabra);
		this.transiciones.add(t);
	}
	
	public int getNumero() {
		return numero;
	}
	public void setNumero(int numero) {
		this.numero = numero;
	}
	public String getPalabra() {
		return palabra;
	}
	public void setPalabra(String palabra) {
		this.palabra = palabra;
	}
	public ArrayList<Transicion> getTransiciones() {
		return transiciones;
	}
	public void setTransiciones(ArrayList<Transicion> transiciones) {
		this.transiciones = transiciones;
	}
	public boolean equivale(Estado e2){
		// Si las palabras no son iguales, no son equivalentes
		if (!this.getPalabra().equals(e2.getPalabra())){
			return false;
		}else{			
			// Si lo son, pero tienen n�mero diferente de transiciones, tampoco
			if ( (this.getTransiciones().size()) != (e2.getTransiciones().size()) ){
				return false;
			}else{
				// Si no tienen transiciones, son iguales (puesto que su nombre tambi�n es igual)
				if ((this.getTransiciones().size()==0)) {
					return true;
				}else{
					// En cualquier otro caso, comprobamos todas las transiciones:
//					boolean aux = true;
					// Si alguna es diferente, no son equivalentes
					for(int i = 0; i<transiciones.size(); i++){
						Estado d1 = this.getTransiciones().get(i).getDestino();
						Estado d2 = e2.getTransiciones().get(i).getDestino();
						if (!d1.equivale(d2)) return false;
					}
					return true;
				}
			}
		}
	}
}
